# Contribution Ladder

This document outlines the various responsibilities of contributor roles for Tanzu Framework
and how to move from interested user to a reviewer.

## Interested

Interested user is anyone who is interested in the project and wants to try out. If you have
reached this far by reading this, you are already a community member :)

Here are some ideas for how you can be more involved and participate in the
community:

* Comment on an issue that you are interested in.
* Submit a pull request to fix an issue.
* Review pull requests.
* Report a bug.
* Participate in the discussion in GitHub issues etc.

## Contributor

Contributors are the people who actively contribute to Framework.

### How to become a contributor

To become a contributor, one must have read the [contributor guide](../CONTRIBUTING.md)
and have made multiple contributions to the project such as authoring or
reviewing PRs, opening issues with bugs, questions, etc, or commenting on
issues with your experiences and opinions. Contributors and maintainers will
do their best to watch for community participants who may make good
contributors to promote them.

### Responsibilities

* Actively contribute to Frameworks codebase.
* Add or update documentation when needed.
* Have issues and PRs assigned to them.
* Responsive to the issues and PRs assigned to them.
* Apply labels, milestones to the issues and PRs.
* Participate in the proposal discussions.
* Perform code reviews.

## Reviewer

Reviewers are able to review code for quality and correctness on some area of Framework.
They are knowledgeable about both the codebase and software engineering principles.

### How to become a reviewer

After you have contributed to an area of Framework consistently, you are
likely ready to help review pull requests either in just that area, or for the
entire repository. You should be knowledgeable about the area in which you are
willing to be a reviewer. To become a reviewer you need to be nominated by a
maintainer.

### Responsibilities

* Expected to be responsive to review requests.
* Responsible for project quality control via code reviews
  * Focus on code quality and correctness, including testing and refactoring
* Responsible for reviewing assigned PRs related to their component of their
  expertise.
